#include <stdio.h>
#include <stdlib.h>
#include <linux/i2c-dev.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define	SLAVE_ADDRESS	0x08

int fd;
char *i2cdev = "/dev/i2c-0";
unsigned char buf[16];

int i2cwrite(char *buf, int len)
{
	if ((write(fd, buf, len)) != len) {
		printf("Err:- i2cwrite\n");
		return(1);
	}
	return(0);
}

int i2cread(int offset, char *buf, int len)
{
	*buf = (char)offset;
	if (i2cwrite(buf,1))
		return(1);
	if (read(fd, buf, len) != len) {
		printf("Err:- i2cread\n");
		return(1);
	}
	return(0);
}

void dump_buf()
{
	int i;
	printf("Get:=");
	for (i=0; i<8; i++) {
		printf("%02XH ",buf[i]);
	}
	printf("%\n");
}

int main(int argc, char *argv[])
{
	printf("**** PSoC I2C TEST ****\n");
	if ((fd = open(i2cdev, O_RDWR)) < 0) {
		printf("Can't open i2c\n");
		exit(1);
	}

	if (ioctl(fd, I2C_SLAVE, SLAVE_ADDRESS) < 0) {
		printf("Unable to get bus access to talk to slave\n");
		exit(1);
	}

	if (i2cread(0,buf,8))
		exit(1);
	dump_buf();
	buf[0] = 0;
	buf[1] = 0xab;
	if (i2cwrite(buf,2))
		exit(1);
	if (i2cread(0,buf,8))
		exit(1);
	dump_buf();
	return 0;
}


